with Unix.System_Calls;
package body Unix.Errno is

   procedure Check(Code: Int) is
      -- Check error and raise the corresponding exception
      Err: Int;
   begin
      if Code = -1 then
	 Err := Unix.System_Calls.Get_Errno;
	 case Err is
	    when EPERM => raise Unix.EPERM;
	    when ENOENT => raise Unix.ENOENT;
	    when ESRCH => raise Unix.ESRCH;
	    when EINTR => raise Unix.EINTR;
	    when EIO => raise Unix.EIO;
	    when ENXIO => raise Unix.ENXIO;
	    when E2BIG => raise Unix.E2BIG;
	    when ENOEXEC => raise Unix.ENOEXEC;
	    when EBADF => raise Unix.EBADF;
	    when ECHILD => raise Unix.ECHILD;
	    when EAGAIN => raise Unix.EAGAIN;
	    when ENOMEM => raise Unix.ENOMEM;
	    when EACCES => raise Unix.EACCES;
	    when EFAULT => raise Unix.EFAULT;
	    when ENOTBLK => raise Unix.ENOTBLK;
	    when EBUSY => raise Unix.EBUSY;
	    when EEXIST => raise Unix.EEXIST;
	    when EXDEV => raise Unix.EXDEV;
	    when ENODEV => raise Unix.ENODEV;
	    when ENOTDIR => raise Unix.ENOTDIR;
	    when EISDIR => raise Unix.EISDIR;
	    when EINVAL => raise Unix.EINVAL;
	    when ENFILE => raise Unix.ENFILE;
	    when EMFILE => raise Unix.EMFILE;
	    when ENOTTY => raise Unix.ENOTTY;
	    when ETXTBSY => raise Unix.ETXTBSY;
	    when EFBIG => raise Unix.EFBIG;
	    when ENOSPC => raise Unix.ENOSPC;
	    when ESPIPE => raise Unix.ESPIPE;
	    when EROFS => raise Unix.EROFS;
	    when EMLINK => raise Unix.EMLINK;
	    when EPIPE => raise Unix.EPIPE;
	    when EDOM => raise Unix.EDOM;
	    when ERANGE => raise Unix.ERANGE;
	    when EDEADLK => raise Unix.EDEADLK;
	    when ENAMETOOLONG => raise Unix.ENAMETOOLONG;
	    when ENOLCK => raise Unix.ENOLCK;
	    when ENOSYS => raise Unix.ENOSYS;
	    when ENOTEMPTY => raise Unix.ENOTEMPTY;
	    when ELOOP => raise Unix.ELOOP;
	    -- when EWOULDBLOCK => raise Unix.EWOULDBLOCK;
	    when ENOMSG => raise Unix.ENOMSG;
	    when EIDRM => raise Unix.EIDRM;
	    when ECHRNG => raise Unix.ECHRNG;
	    when EL2NSYNC => raise Unix.EL2NSYNC;
	    when EL3HLT => raise Unix.EL3HLT;
	    when EL3RST => raise Unix.EL3RST;
	    when ELNRNG => raise Unix.ELNRNG;
	    when EUNATCH => raise Unix.EUNATCH;
	    when ENOCSI => raise Unix.ENOCSI;
	    when EL2HLT => raise Unix.EL2HLT;
	    when EBADE => raise Unix.EBADE;
	    when EBADR => raise Unix.EBADR;
	    when EXFULL => raise Unix.EXFULL;
	    when ENOANO => raise Unix.ENOANO;
	    when EBADRQC => raise Unix.EBADRQC;
	    when EBADSLT => raise Unix.EBADSLT;
	    -- when EDEADLOCK => raise Unix.EDEADLOCK;
	    when EBFONT => raise Unix.EBFONT;
	    when ENOSTR => raise Unix.ENOSTR;
	    when ENODATA => raise Unix.ENODATA;
	    when ETIME => raise Unix.ETIME;
	    when ENOSR => raise Unix.ENOSR;
	    when ENONET => raise Unix.ENONET;
	    when ENOPKG => raise Unix.ENOPKG;
	    when EREMOTE => raise Unix.EREMOTE;
	    when ENOLINK => raise Unix.ENOLINK;
	    when EADV => raise Unix.EADV;
	    when ESRMNT => raise Unix.ESRMNT;
	    when ECOMM => raise Unix.ECOMM;
	    when EPROTO => raise Unix.EPROTO;
	    when EMULTIHOP => raise Unix.EMULTIHOP;
	    when EDOTDOT => raise Unix.EDOTDOT;
	    when EBADMSG => raise Unix.EBADMSG;
	    when EOVERFLOW => raise Unix.EOVERFLOW;
	    when ENOTUNIQ => raise Unix.ENOTUNIQ;
	    when EBADFD => raise Unix.EBADFD;
	    when EREMCHG => raise Unix.EREMCHG;
	    when ELIBACC => raise Unix.ELIBACC;
	    when ELIBBAD => raise Unix.ELIBBAD;
	    when ELIBSCN => raise Unix.ELIBSCN;
	    when ELIBMAX => raise Unix.ELIBMAX;
	    when ELIBEXEC => raise Unix.ELIBEXEC;
	    when EILSEQ => raise Unix.EILSEQ;
	    when ERESTART => raise Unix.ERESTART;
	    when ESTRPIPE => raise Unix.ESTRPIPE;
	    when EUSERS => raise Unix.EUSERS;
	    when ENOTSOCK => raise Unix.ENOTSOCK;
	    when EDESTADDRREQ => raise Unix.EDESTADDRREQ;
	    when EMSGSIZE => raise Unix.EMSGSIZE;
	    when EPROTOTYPE => raise Unix.EPROTOTYPE;
	    when ENOPROTOOPT => raise Unix.ENOPROTOOPT;
	    when EPROTONOSUPPORT => raise Unix.EPROTONOSUPPORT;
	    when ESOCKTNOSUPPORT => raise Unix.ESOCKTNOSUPPORT;
	    when EOPNOTSUPP => raise Unix.EOPNOTSUPP;
	    when EPFNOSUPPORT => raise Unix.EPFNOSUPPORT;
	    when EAFNOSUPPORT => raise Unix.EAFNOSUPPORT;
	    when EADDRINUSE => raise Unix.EADDRINUSE;
	    when EADDRNOTAVAIL => raise Unix.EADDRNOTAVAIL;
	    when ENETDOWN => raise Unix.ENETDOWN;
	    when ENETUNREACH => raise Unix.ENETUNREACH;
	    when ENETRESET => raise Unix.ENETRESET;
	    when ECONNABORTED => raise Unix.ECONNABORTED;
	    when ECONNRESET => raise Unix.ECONNRESET;
	    when ENOBUFS => raise Unix.ENOBUFS;
	    when EISCONN => raise Unix.EISCONN;
	    when ENOTCONN => raise Unix.ENOTCONN;
	    when ESHUTDOWN => raise Unix.ESHUTDOWN;
	    when ETOOMANYREFS => raise Unix.ETOOMANYREFS;
	    when ETIMEDOUT => raise Unix.ETIMEDOUT;
	    when ECONNREFUSED => raise Unix.ECONNREFUSED;
	    when EHOSTDOWN => raise Unix.EHOSTDOWN;
	    when EHOSTUNREACH => raise Unix.EHOSTUNREACH;
	    when EALREADY => raise Unix.EALREADY;
	    when EINPROGRESS => raise Unix.EINPROGRESS;
	    when ESTALE => raise Unix.ESTALE;
	    when EUCLEAN => raise Unix.EUCLEAN;
	    when ENOTNAM => raise Unix.ENOTNAM;
	    when ENAVAIL => raise Unix.ENAVAIL;
	    when EISNAM => raise Unix.EISNAM;
	    when EREMOTEIO => raise Unix.EREMOTEIO;
	    when EDQUOT => raise Unix.EDQUOT;
	    when others => raise Unix.Unknown_Error;
	 end case;
      end if;
   end Check;

end Unix.Errno;




