-- Autor: Javier Miranda
-- Fecha: 11/Dic/98

package Unix is

   procedure Perror (Arg: String := "");

   -- Files system calls
   function Creat(Path : String;
                   Perms: Integer) return Natural;

   function Open (Path : String;
                  Flags: Integer) return Natural;

   -- Flags values:
   O_RDONLY: constant := 0;
   O_WRONLY: constant := 1;
   O_RDWR  : constant := 2;

   procedure Write(Fid   : Natural;
                   Buff  : String;
                   Nbytes: Natural);

   procedure Read(Fid        : in  Natural;
                  Buff       : out String;
                  Nbytes     : in  Natural;
                  Nbytes_Read: out natural);

   procedure Close(Fid: Natural);

   function Lseek(Fid   : Natural;
                  Offset: Integer;
                  Whence: Integer) return Integer;

   -- Whence values
   SEEK_SET: constant:= 0;
   SEEK_CUR: constant:= 1;
   SEEK_END: constant:= 2;

   function Dup(Fid: Natural) return Natural;

   -- Processes system calls
   function Fork return Natural;

   procedure Execlp(Path: String;
                   Arg0: String;
                   Arg1: String := "";
                   Arg2: String := "";
                   Arg3: String := "";
                   Arg4: String := "";
                   Arg5: String := "";
                   Arg6: String := "";
                   Arg7: String := "";
                   Arg8: String := "";
                   Arg9: String := "");


   type Natural_Ptr is access all Natural;
   function Wait(Status: Natural_Ptr) return Natural;

   procedure Sys_Exit(Status: Integer);

   -- Processes communication
   type T_Fildes is array(0..1) of Integer;
   procedure Pipe(Fildes: out T_Fildes);

   EPERM, ENOENT, ESRCH, EINTR, EIO, ENXIO, E2BIG, ENOEXEC, EBADF,
   ECHILD, EAGAIN, ENOMEM, EACCES, EFAULT, ENOTBLK, EBUSY, EEXIST, EXDEV,
   ENODEV, ENOTDIR, EISDIR, EINVAL, ENFILE, EMFILE, ENOTTY, ETXTBSY,
   EFBIG, ENOSPC, ESPIPE, EROFS, EMLINK, EPIPE, EDOM, ERANGE, EDEADLK,
   ENAMETOOLONG, ENOLCK, ENOSYS, ENOTEMPTY, ELOOP, EWOULDBLOCK, ENOMSG,
   EIDRM, ECHRNG, EL2NSYNC, EL3HLT, EL3RST, ELNRNG, EUNATCH, ENOCSI,
   EL2HLT, EBADE, EBADR, EXFULL, ENOANO, EBADRQC, EBADSLT, EDEADLOCK,
   EBFONT, ENOSTR, ENODATA, ETIME, ENOSR, ENONET, ENOPKG, EREMOTE,
   ENOLINK, EADV, ESRMNT, ECOMM, EPROTO, EMULTIHOP, EDOTDOT, EBADMSG,
   EOVERFLOW, ENOTUNIQ, EBADFD, EREMCHG, ELIBACC, ELIBBAD, ELIBSCN,
   ELIBMAX, ELIBEXEC, EILSEQ, ERESTART, ESTRPIPE, EUSERS, ENOTSOCK,
   EDESTADDRREQ, EMSGSIZE, EPROTOTYPE, ENOPROTOOPT, EPROTONOSUPPORT,
   ESOCKTNOSUPPORT, EOPNOTSUPP, EPFNOSUPPORT, EAFNOSUPPORT, EADDRINUSE,
   EADDRNOTAVAIL, ENETDOWN, ENETUNREACH, ENETRESET, ECONNABORTED,
   ECONNRESET, ENOBUFS, EISCONN, ENOTCONN, ESHUTDOWN, ETOOMANYREFS,
   ETIMEDOUT, ECONNREFUSED, EHOSTDOWN, EHOSTUNREACH, EALREADY,
   EINPROGRESS, ESTALE, EUCLEAN, ENOTNAM, ENAVAIL, EISNAM, EREMOTEIO,
   EDQUOT, UNKNOWN_ERROR: exception;
end Unix;
