with Interfaces.C;
private package Unix.Errno is
   use Interfaces.C;

      EPERM	: constant Int :=  1; -- Operation not permitted 
      ENOENT	: constant Int :=  2; -- No such file or directory 
      ESRCH	: constant Int :=  3; -- No such process 
      EINTR	: constant Int :=  4; -- Interrupted system call 
      EIO       : constant Int :=  5; -- I/O error 
      ENXIO	: constant Int :=  6; -- No such device or address 
      E2BIG	: constant Int :=  7; -- Arg list too long 
      ENOEXEC	: constant Int :=  8; -- Exec format error 
      EBADF	: constant Int :=  9; -- Bad file number 
      ECHILD	: constant Int := 10; -- No child processes 
      EAGAIN	: constant Int := 11; -- Try again 
      ENOMEM	: constant Int := 12; -- Out of memory 
      EACCES	: constant Int := 13; -- Permission denied 
      EFAULT	: constant Int := 14; -- Bad address 
      ENOTBLK	: constant Int := 15; -- Block device required 
      EBUSY	: constant Int := 16; -- Device or resource busy 
      EEXIST	: constant Int := 17; -- File exists 
      EXDEV	: constant Int := 18; -- Cross-device link 
      ENODEV	: constant Int := 19; -- No such device 
      ENOTDIR	: constant Int := 20; -- Not a directory 
      EISDIR	: constant Int := 21; -- Is a directory 
      EINVAL	: constant Int := 22; -- Invalid argument 
      ENFILE	: constant Int := 23; -- File table overflow 
      EMFILE	: constant Int := 24; -- Too many open files 
      ENOTTY	: constant Int := 25; -- Not a typewriter 
      ETXTBSY	: constant Int := 26; -- Text file busy 
      EFBIG	: constant Int := 27; -- File too large 
      ENOSPC	: constant Int := 28; -- No space left on device 
      ESPIPE	: constant Int := 29; -- Illegal seek 
      EROFS	: constant Int := 30; -- Read-only file system 
      EMLINK	: constant Int := 31; -- Too many links 
      EPIPE	: constant Int := 32; -- Broken pipe 
      EDOM      : constant Int := 33; -- Math argument out of domain of 
                                          -- func 
      ERANGE	: constant Int := 34; -- Math result not representable 
      EDEADLK	: constant Int := 35; -- Resource deadlock would occur 
      ENAMETOOLONG:constant Int:= 36; -- File name too long 
      ENOLCK	: constant Int := 37; -- No record locks available 
      ENOSYS	: constant Int := 38; -- Function not implemented 
      ENOTEMPTY : constant Int := 39; -- Directory not empty 
      ELOOP	: constant Int := 40; -- Too many symbolic links 
      -- encountered 
      EWOULDBLOCK:constant Int :=EAGAIN; -- Operation would block 
      ENOMSG	: constant Int := 42; -- No message of desired type 
      EIDRM	: constant Int := 43; -- Identifier removed 
      ECHRNG	: constant Int := 44; -- Channel number out of range 
      EL2NSYNC  : constant Int := 45; -- Level 2 not synchronized 
      EL3HLT	: constant Int := 46; -- Level 3 halted 
      EL3RST	: constant Int := 47; -- Level 3 reset 
      ELNRNG	: constant Int := 48; -- Link number out of range 
      EUNATCH	: constant Int := 49; -- Protocol driver not attached 
      ENOCSI	: constant Int := 50; -- No CSI structure available 
      EL2HLT	: constant Int := 51; -- Level 2 halted 
      EBADE	: constant Int := 52; -- Invalid exchange 
      EBADR	: constant Int := 53; -- Invalid request descriptor 
      EXFULL	: constant Int := 54; -- Exchange full 
      ENOANO	: constant Int := 55; -- No anode 
      EBADRQC	: constant Int := 56; -- Invalid request code 
      EBADSLT	: constant Int := 57; -- Invalid slot 
      
      EDEADLOCK : constant Int :=EDEADLK;
      
      EBFONT	: constant Int := 59; -- Bad font file format 
      ENOSTR	: constant Int := 60; -- Device not a stream 
      ENODATA	: constant Int := 61; -- No data available 
      ETIME	: constant Int := 62; -- Timer expired 
      ENOSR	: constant Int := 63; -- Out of streams resources 
      ENONET	: constant Int := 64; -- Machine is not on the network 
      ENOPKG	: constant Int := 65; -- Package not installed 
      EREMOTE	: constant Int := 66; -- Object is remote 
      ENOLINK	: constant Int := 67; -- Link has been severed 
      EADV	: constant Int := 68; -- Advertise error 
      ESRMNT	: constant Int := 69; -- Srmount error 
      ECOMM	: constant Int := 70; -- Communication error on send 
      EPROTO	: constant Int := 71; -- Protocol error 
      EMULTIHOP : constant Int := 72; -- Multihop attempted 
      EDOTDOT	: constant Int := 73; -- RFS specific error 
      EBADMSG	: constant Int := 74; -- Not a data message 
      EOVERFLOW : constant Int := 75; -- Value too large for defined data 
      -- type 
      ENOTUNIQ  : constant Int := 76; -- Name not unique on network 
      EBADFD	: constant Int := 77; -- File descriptor in bad state 
      EREMCHG	: constant Int := 78; -- Remote address changed 
      ELIBACC	: constant Int := 79; -- Can not access a needed shared 
      -- library 
      ELIBBAD	: constant Int := 80; -- Accessing a corrupted shared 
      -- library 
      ELIBSCN	: constant Int := 81; -- .lib section in a.out corrupted 
      ELIBMAX	: constant Int := 82; -- Attempting to link in too many 
      -- shared libraries 
      ELIBEXEC  : constant Int := 83; -- Cannot exec a shared library 
                                          -- directly 
      EILSEQ    : constant Int := 84; -- Illegal byte sequence 
      ERESTART  : constant Int := 85; -- Interrupted system call should be
                                          -- restarted 
      ESTRPIPE  : constant Int := 86; -- Streams pipe error 
      EUSERS	: constant Int := 87; -- Too many users 
      ENOTSOCK  : constant Int := 88; -- Socket operation on non-socket 
      EDESTADDRREQ:constant Int:= 89; -- Destination address required 
      EMSGSIZE  : constant Int := 90; -- Message too long 
      EPROTOTYPE: constant Int := 91; -- Protocol wrong type for socket 
      ENOPROTOOPT: constant Int:= 92; -- Protocol not available 
      EPROTONOSUPPORT:constant Int:=93; -- Protocol not supported 
      ESOCKTNOSUPPORT:constant Int:=94; -- Socket type not supported 
      EOPNOTSUPP   : constant Int :=95; -- Operation not supported on 
      -- transport endpoint 
      EPFNOSUPPORT : constant Int :=96; -- Protocol family not supported 
      EAFNOSUPPORT : constant Int :=97; -- Address family not supported by 
      -- protocol 
      EADDRINUSE   : constant Int :=98; -- Address already in use 
      EADDRNOTAVAIL: constant Int :=99; -- Cannot assign requested address 
      ENETDOWN     : constant Int :=100; -- Network is down 
      ENETUNREACH  : constant Int :=101; -- Network is unreachable 
      ENETRESET    : constant Int :=102; -- Network dropped connection 
                                             -- because of reset 
      ECONNABORTED : constant Int :=103; -- Software caused connection 
                                             -- abort 
      ECONNRESET   : constant Int :=104; -- Connection reset by peer 
      ENOBUFS      : constant Int :=105; -- No buffer space available 
      EISCONN      : constant Int :=106; -- Transport endpoint is already 
                                             -- connected 
      ENOTCONN     : constant Int :=107; -- Transport endpoint is not 
                                             -- connected 
      ESHUTDOWN    : constant Int :=108; -- Cannot send after transport 
                                             -- endpoint shutdown 
      ETOOMANYREFS : constant Int :=109; -- Too many references: cannot 
                                             -- splice 
      ETIMEDOUT    : constant Int :=110; -- Connection timed out 
      ECONNREFUSED : constant Int :=111; -- Connection refused 
      EHOSTDOWN    : constant Int :=112; -- Host is down 
      EHOSTUNREACH : constant Int :=113; -- No route to host 
      EALREADY     : constant Int :=114; -- Operation already in progress 
      EINPROGRESS  : constant Int :=115; -- Operation now in progress 
      ESTALE       : constant Int :=116; -- Stale NFS file handle 
      EUCLEAN      : constant Int :=117; -- Structure needs cleaning 
      ENOTNAM      : constant Int :=118; -- Not a XENIX named type file 
      ENAVAIL      : constant Int :=119; -- No XENIX semaphores available 
      EISNAM       : constant Int :=120; -- Is a named type file 
      EREMOTEIO    : constant Int :=121; -- Remote I/O error 
      EDQUOT       : constant Int :=122; -- Quota exceeded 

      procedure Check(Code: Int);
      -- Check error and raise the corresponding exception
end Unix.Errno;
